From 9ad1fbc47843a13550438c1a3d26a24b8ccb0c87 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 01 2020 22:05:01 +0000
Subject: [PATCH 75/2232] Pass ending comment to end_block


Clang-format doesn't always like the same ending comment as the start of
the block. In particular it wants:

    inline namespace cxxbridge01 {
      ...
    } // namespace cxxbridge01

---

diff --git a/gen/out.rs b/gen/out.rs
index 8d7499b..506ce6c 100644
--- a/gen/out.rs
+++ b/gen/out.rs
@@ -5,8 +5,7 @@ pub(crate) struct OutFile {
     pub header: bool,
     content: Vec<u8>,
     section_pending: bool,
-    blocks: Vec<&'static str>,
-    blocks_pending: usize,
+    blocks_pending: Vec<&'static str>,
 }
 
 impl OutFile {
@@ -16,8 +15,7 @@ impl OutFile {
             header,
             content: Vec::new(),
             section_pending: false,
-            blocks: Vec::new(),
-            blocks_pending: 0,
+            blocks_pending: Vec::new(),
         }
     }
 
@@ -27,17 +25,13 @@ impl OutFile {
     }
 
     pub fn begin_block(&mut self, block: &'static str) {
-        self.blocks.push(block);
-        self.blocks_pending += 1;
+        self.blocks_pending.push(block);
     }
 
-    pub fn end_block(&mut self) {
-        if self.blocks_pending > 0 {
-            self.blocks_pending -= 1;
-        } else {
+    pub fn end_block(&mut self, block: &'static str) {
+        if self.blocks_pending.pop().is_none() {
             self.content.extend_from_slice(b"} // ");
-            self.content
-                .extend_from_slice(self.blocks.pop().unwrap().as_bytes());
+            self.content.extend_from_slice(block.as_bytes());
             self.content.push(b'\n');
             self.section_pending = true;
         }
@@ -51,13 +45,12 @@ impl OutFile {
 impl Write for OutFile {
     fn write_str(&mut self, s: &str) -> fmt::Result {
         if !s.is_empty() {
-            if self.blocks_pending > 0 {
+            if !self.blocks_pending.is_empty() {
                 self.content.push(b'\n');
-                for block in &self.blocks[self.blocks.len() - self.blocks_pending..] {
+                for block in self.blocks_pending.drain(..) {
                     self.content.extend_from_slice(block.as_bytes());
                     self.content.extend_from_slice(b" {\n");
                 }
-                self.blocks_pending = 0;
                 self.section_pending = false;
             } else if self.section_pending {
                 self.content.push(b'\n');
diff --git a/gen/write.rs b/gen/write.rs
index a2c1b7a..99ea418 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -54,7 +54,7 @@ pub(super) fn gen(namespace: Vec<String>, apis: &[Api], types: &Types, header: b
             out.next_section();
             write(out, efn, types);
         }
-        out.end_block();
+        out.end_block("extern \"C\"");
     }
 
     for api in apis {
@@ -125,8 +125,8 @@ fn write_include_cxxbridge(out: &mut OutFile, types: &Types) {
             }
         }
     }
-    out.end_block();
-    out.end_block();
+    out.end_block("namespace cxxbridge01");
+    out.end_block("namespace rust");
 }
 
 fn write_struct(out: &mut OutFile, strct: &Struct) {
@@ -434,7 +434,7 @@ fn write_generic_instantiations(out: &mut OutFile, types: &Types) {
             }
         }
     }
-    out.end_block();
+    out.end_block("extern \"C\"");
 
     out.begin_block("namespace rust");
     out.begin_block("inline namespace cxxbridge01");
@@ -445,8 +445,8 @@ fn write_generic_instantiations(out: &mut OutFile, types: &Types) {
             }
         }
     }
-    out.end_block();
-    out.end_block();
+    out.end_block("namespace cxxbridge01");
+    out.end_block("namespace rust");
 }
 
 fn write_rust_box_extern(out: &mut OutFile, ident: &Ident) {

